var MynotificationAssistant = Class.create({
	
	initialize: function() {
		
	},
	
	ToggleOpt: {
        modelProperty: 'value',
        enableProp: 'enabled',        
    },
	

	setup: function() {
		
		$('currentnotificationrow').observe(Mojo.Event.tap, this.showNotificationFilePicker.bindAsEventListener(this));
		$('currentringtonerow').observe(Mojo.Event.tap, this.showRingtoneFilePicker.bindAsEventListener(this));
		$('currentalertrow').observe(Mojo.Event.tap, this.showAlertFilePicker.bindAsEventListener(this));
		
		this.getCurrentNotification();
		this.getCurrentRingtone();
		this.getCurrentAlert();
		
		//App Menu - Remove default items and add only Edit & Help items.
		var appMenuModel = {
	        visible: true,
	        items: [Mojo.Menu.editItem,{label:$L('Help...'), command:Mojo.Menu.helpCmd}
	            ]
	        };
		this.controller.setupWidget(Mojo.Menu.appMenu, {omitDefaultItems:true}, appMenuModel);								
	},
	
	cleanup : function() {
	},	
	
	handleCommand: function(event) {
		if (event.type == Mojo.Event.command) {
			if(event.command == Mojo.Menu.helpCmd) {
				this.controller.serviceRequest('palm://com.palm.applicationManager', {
					method: 'open',
					parameters: {'id': 'com.palm.app.help',params: {'target': 'http://predev.wikidot.com'}}});
			}
		}
	},	

	// Alert Picking
	getCurrentAlert: function() {
		this.getCurrentAlertReq = SystemService.getAlerts(this.getCurrentAlertQuery.bind(this));
	},
	
	getCurrentAlertQuery: function(payload) {		
		if (payload.alerttone) {
			$('currentalert').innerHTML = payload.alerttone.name;
			this.currAlertPath = payload.alerttone.fullPath;	
		}
		else 
			$('currentalert').innerHTML = $L("Pick an alert");
		
	},
	
	showAlertFilePicker: function(event) {
		var params = {"kinds": ["ringtone"],"filePath":this.currAlertPath,"onSelect":this.selectedAlertFile.bind(this),actionType:"attach",actionName: $L("Done")};
		Mojo.FilePicker.pickFile(params,Mojo.Controller.stageController);
	},
	
	selectedAlertFile: function(file) {		
		//var params = {"fullPath": encodeURIComponent(file.fullPath), "name":file.name};
		this.setAlertReq = SystemService.setAlerts(file);
		$('currentalert').innerHTML = file.name;
	},	
	
	// Notification Picking
	getCurrentNotification: function() {
		this.getCurrentNotificationReq = SystemService.getNotifications(this.getCurrentNotificationQuery.bind(this));
	},
	
	getCurrentNotificationQuery: function(payload) {		
		if (payload.notificationtone) {
			$('currentnotification').innerHTML = payload.notificationtone.name;
			this.currNotificationPath = payload.notificationtone.fullPath;	
		}
		else 
			$('currentnotification').innerHTML = $L("Pick a notification");
		
	},
	
	showNotificationFilePicker: function(event) {
		var params = {"kinds": ["ringtone"],"filePath":this.currNotificationPath,"onSelect":this.selectedNotificationFile.bind(this),actionType:"attach",actionName: $L("Done")};
		Mojo.FilePicker.pickFile(params,Mojo.Controller.stageController);
	},
	
	selectedNotificationFile: function(file) {		
		//var params = {"fullPath": encodeURIComponent(file.fullPath), "name":file.name};
		this.setNotificationReq = SystemService.setNotifications(file);
		$('currentnotification').innerHTML = file.name;
	},

	// Ringtone Picker
	getCurrentRingtone: function() {
		this.getCurrentRingtoneReq = SystemService.getRingtone(this.getCurrentRingtoneQuery.bind(this));
	},
	
	getCurrentRingtoneQuery: function(payload) {		
		if (payload.ringtone) {
			$('currentringtone').innerHTML = payload.ringtone.name;
			this.currRingtonePath = payload.ringtone.fullPath;	
		}
		else 
			$('currentringtone').innerHTML = $L("Pick a ringtone");
		
	},
	
	showRingtoneFilePicker: function(event) {
		var params = {"kinds": ["ringtone"],"filePath":this.currRingtonePath,"onSelect":this.selectedRingtoneFile.bind(this),actionType:"attach",actionName: $L("Done")};
		Mojo.FilePicker.pickFile(params,Mojo.Controller.stageController);
	},
	
	selectedRingtoneFile: function(file) {		
		//var params = {"fullPath": encodeURIComponent(file.fullPath), "name":file.name};
		this.setRingtoneReq = SystemService.setRingtone(file);
		$('currentringtone').innerHTML = file.name;
	},
	
});
