function AppListAssistant(item)
{
	this.item = item;
	this.listModel = {items:[]};
}

AppListAssistant.prototype.setup = function()
{
	// setup list title
	this.controller.get('listTitle').innerHTML = this.item.name;
	
	// setup list widget
	this.controller.setupWidget('appList', { itemTemplate: "appList/rowTemplate", swipeToDelete: false, reorderable: false }, this.listModel);
	Mojo.Event.listen(this.controller.get('appList'), Mojo.Event.listTap, this.listTapHandler.bindAsEventListener(this));
	
	// load list items
	switch (this.item.list)
	{
		case 'list_upgrades':	IPKGService.list_upgrades(this.onList.bindAsEventListener(this));	break;
		case 'list':			IPKGService.list(this.onList.bindAsEventListener(this));			break;
		case 'list_installed':	IPKGService.list_installed(this.onList.bindAsEventListener(this));	break;
		default: /* error */  break;
	}
}

AppListAssistant.prototype.listTapHandler = function(event)
{
	IPKGService.info(this.onInfo.bindAsEventListener(this), event.item.pkg);
}

AppListAssistant.prototype.onInfo = function(payload)
{
	if (!payload)
		console.log('error');
	else 
	{
		//console.log(payload.errorCode + ' - ' + payload.errorText);
		console.log(payload.Status);
	}
}

AppListAssistant.prototype.onList = function(payload)
{
	if (!payload)
		// error / no apps
		return;
	else 
	{
		for (var pkg in payload) 
		{
			//console.log(pkg);
			
			// push package to app list model
			this.listModel.items.push(
			{
				pkg:			pkg,
				version:		payload[pkg].version,
				description:	payload[pkg].description
			});
		}
		
		// update list widget
		this.controller.get('appList').mojo.noticeUpdatedItems(0, this.listModel.items);
	}
}

AppListAssistant.prototype.activate = function(event) {}

AppListAssistant.prototype.deactivate = function(event) {}

AppListAssistant.prototype.cleanup = function(event) {}
