function MainAssistant()
{
	// main list model
	this.mainModel = 
	{
		items: [
		{
			name: $L('Check for Updates'),	// displays in list
			scene: 'app-list',				// scene that will be pushed on tap 
			list: 'list_upgrades'			// variable used by the app-list scene to display the correct list other scenes will have different variables
		}, 
		{
			name: $L('WebOS Applications'),
			scene: 'app-list',
			list: 'list'
		}, 
		{
			name: $L('WebOS Patches'),
			scene: false
		}, 
		{
			name: $L('List of Installed Items'),
			scene: 'app-list',
			list: 'list_installed'
		}, 
		{
			name: $L('Alpha List of Everything'),
			scene: false
		}]
	};
	
	// spinner model
	this.spinnerModel = {spinning: true};
}

MainAssistant.prototype.setup = function()
{
	// setup spinner model
	this.controller.setupWidget('spinner', {spinnerSize: 'large'}, this.spinnerModel);
	
	// setup list model
	this.controller.setupWidget('mainList', { itemTemplate: "main/rowTemplate", swipeToDelete: false, reorderable: false }, this.mainModel);
	Mojo.Event.listen(this.controller.get('mainList'), Mojo.Event.listTap, this.listTapHandler.bindAsEventListener(this));
	
	// hide the list while we update ipkg
	this.controller.get('mainList').style.display = "none";
	
	// initiate update
	IPKGService.update(this.onUpdate.bindAsEventListener(this));
}

MainAssistant.prototype.listTapHandler = function(event)
{
	if (event.item.scene === false) 
	{
		// no scene elemnt, this should never happen once all the items have a scene
	}
	else
	{
		this.controller.stageController.pushScene(event.item.scene, event.item);
	}
	
}

MainAssistant.prototype.onUpdate = function(payload)
{
	if (!payload) 
	{
		// error
		return;
	}
	else if (payload.returnVal != undefined) 
	{
		console.log(payload.returnVal);
		
		// stop and hide the spinner
		this.spinnerModel.spinning = false;
		this.controller.modelChanged(this.spinnerModel);
		this.controller.get('spinner').style.display = "none";
		
		// show the list
		this.controller.get('mainList').style.display = "inline";
	}
}

MainAssistant.prototype.activate = function(event) {}

MainAssistant.prototype.deactivate = function(event) {}

MainAssistant.prototype.cleanup = function(event) {}
